<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
        integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">

</head>

<body>
    <div class="container jumbotron">
        <h1 class="text-center p-lg-1">Thông tin người dùng</h1>
        <div class="form-group">
            <label for="">First Name</label>
            <input type="text" id="input-firstname" class="form-coltrol">
        </div>
        <div class="form-group">
            <label for="">Last Name</label>
            <input type="text" id="input-lastname" class="form-coltrol">
        </div>
        <div class="form-group">
            <label for="">Country</label>
            <input type="text" id="input-country" class="form-coltrol">
        </div>
        <div class="form-group">
            <label for="">Subject</label>
            <textarea name="" id="textarea-subject" class="form-coltrol"></textarea>
            
        </div>
        <div class="form-row">
            <div class="col">
                <button class="btn btn-success w-50" id="button-edit" onclick="onBtnUpdateClick()">Sửa</button>
            </div>
            <div class="col">
                <a class="class = btn btn-primary" href="task 29.60.html">Quay lại</a>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnUpdateClick() {
        //khai báo đối tượng
        var vUserObj = {
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
        }
        var vUrlString = window.location.href;
        var vUrlObj = new URL(vUrlString);
        var vUrlId = vUrlObj.searchParams.get("id");
        //B1 thu thập dữ liệu đưa vào đối tượng UserObj
        thuThapDuLieu(vUserObj);
        //B2 Kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieu(vUserObj);
        if (vDuLieuHopLe) {
            var vXMLHttp = new XMLHttpRequest();
            //B3 gọi api chỉnh sửa dữ liệu
            goiApiUpdateUser(vUrlId, vXMLHttp,vUserObj);
            vXMLHttp.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    //B4 Xử lý hiển thị
                    alert("Cập nhật thông tin thành công: " + this.responseText);
                }
            }
            
            

            
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function thuThapDuLieu(paramUserObj) {
            var vInputFirstname = document.getElementById("input-firstname");
            var vInputLastname = document.getElementById("input-lastname");
            var vInputCountry = document.getElementById("input-country");
            var vTextareaSubject = document.getElementById("textarea-subject");
            paramUserObj.firstname = vInputFirstname.value.trim();
            paramUserObj.lastname = vInputLastname.value.trim();
            paramUserObj.country = vInputCountry.value.trim();
            paramUserObj.subject = vTextareaSubject.value.trim();
        }
        function kiemTraDuLieu(paramUserObj) {
            if (paramUserObj.firstname == "") {
                alert("Chưa nhập firstname!");
                return false;
            }
            if (paramUserObj.lastname == "") {
                alert("Chưa nhập lastname!");
                return false;
            }
            if (paramUserObj.country == "") {
                alert("Chưa nhập country!");
                return false;
            }
            if (paramUserObj.subject == "") {
                alert("Chưa nhập subject!");
                return false;
            }
            return true;
        }
        function goiApiUpdateUser(paramUrlId, paramXmlHttp,paramUserObj) {
            var vUrlUpdateInfo = gBASE_URL + "/" + paramUrlId;
            paramXmlHttp.open("PUT", vUrlUpdateInfo);
          
            paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            paramXmlHttp.send(JSON.stringify(paramUserObj));
        }
    }
</script>